<template v-loading="isLoading">
  <div class="bg-background5 overflow-y-auto fixed top-0 left-0 right-0 bottom-0">
    <el-dialog v-model="dialogVisible" :show-close="false" align-center width="80%" custom-class="my-dialog" style="background-color: var(--background5);" v-if="operatorId === 0 && !isFromShopOwner">
      <div style="word-break: break-word;">
        <p v-if="checkQrUrlApp" class="mb-4">{{ sportQrHelper.getLang('Please show this page to Cashier. Please keep this website page or take a screenshot of the page for verification of the winning.', language) }}</p>
        <p v-else class="mb-4">{{ $t('Please show this page to Cashier. Please keep this website page or take a screenshot of the page for verification of the winning.', language) }}</p>
        <div class="flex justify-end"><el-button @click="dialogVisible = false" class="el-button--primary">{{ $t('ok') }}</el-button></div>
      </div>
    </el-dialog>
    <div class="px-4 py-[10px] flex justify-between items-center h-[52px] bg-background3 border-b-2 border-primary" v-if="operatorId === 0">
      <div class="flex">
        <img :src="getAssetImage('assets/common/568win-peru.png')" alt="568win-logo" class="w-20 h-7 object-contain"/>
        <div class="flex justify-center items-center mx-4">
          <button class="x-logo"></button>
        </div>
        <img :src="logo.ImagePath" alt="company-logo" class="w-20 h-7 object-contain"/>
      </div>
      <div class="languages flex items-center fc-text" @click="toggleSidebar">
        <div class="icon-lang mr-2">
          <img :src="getAssetImage(`assets/materials/languageIcon/square/${defaultLanguage}.png`)"/>
        </div>
        <span class="profile-menu-title">{{ defaultLanguageForDisplay }}</span>
      </div>
    </div>
    <div
      v-if="operatorId === 0 || isFromPreviousQrPage"
      class="max-w-[640px] m-auto"
    >
      <div class="m-4 border-2 border-color rounded-lg" v-if="allSportBets.length > 1">
        <p v-if="!isFromPreviousQrPage && checkQrUrlApp && !isFromShopOwner" class="mx-4 mt-4">
          {{ sportQrHelper.getLang('Please keep this website page or', language) }}
          <span class="fc-hint">
               {{ sportQrHelper.getLang('Take a Screenshot', language) }}
          </span> 
            {{ sportQrHelper.getLang('of the page for verification of the winning.', language) }}
        </p>
        <p v-else-if="!isFromShopOwner" class="mx-4 mt-4 a1">
          {{ $t('Please keep this website page or') }}
          <span class="fc-hint">
               {{ $t('Take a Screenshot') }}
          </span> 
            {{ $t('of the page for verification of the winning.') }}
        </p>
        <div class="flex justify-center items-center px-4 py-2" v-if="!isFromShopOwner">
          <svg xmlns="http://www.w3.org/2000/svg" width="120" height="120" viewBox="0 0 122 122" fill="none">
            <path d="M106.128 1H121V15.8925M106.128 121H121V106.108M15.8724 1H1V15.8925M15.8724 121H1V106.108" stroke="#31C46E" stroke-linecap="round" stroke-linejoin="round"/>
          </svg>
          <qrcode-vue
            id="qrCode"
            :value="link"
            :size="parseInt('110')"
            class="p-2 bg-white absolute"
          >
          </qrcode-vue>
        </div>
        <div class="border-t-2 border-color px-4 py-2 flex justify-between" v-if="!isFromPreviousQrPage && totalPayoutForDisplay > 0">
          <p v-if="checkQrUrlApp">{{ sportQrHelper.getLang('Total Payout', language) }}</p>
          <p v-else>{{ $t('Total Payout') }}</p>
          <p><span class="text-base">{{ numberFormatHelper.addAccountingFormat(totalPayoutForDisplay) }}</span> {{ currency }}</p>
        </div>
         <div class="border-t-2 border-color px-4 py-2 flex justify-between" v-if="!isFromPreviousQrPage && totalStakeUnpaidForDisplay > 0">
            <p v-if="checkQrUrlApp">{{ sportQrHelper.getLang('total_stake', language) }}</p>
            <p v-else>{{ $t('total_stake') }}</p>
            <p><span class="text-base">{{ numberFormatHelper.addAccountingFormat(totalStakeUnpaidForDisplay) }}</span> {{ currency }}</p>
          </div>
      </div>
    </div>
    <div v-if="allSportBets.length > 0" class="max-w-[640px] m-auto">
      <sport-qr-unpaid-bet-detail
        :allSportBets = "allSportBets"
        :unPaidSportBets="unPaidSportBets"
        :operatorId="operatorId"
        :operatorToken="operatorToken"
        :isFromPreviousQrPage="isFromPreviousQrPage"
        :totalStakeUnpaidForDisplay="totalStakeUnpaidForDisplay"
        :onPayTicket="onPayTicket"
        :isPayTicketLoading="isPayTicketLoading"
        :link="link"
      />

      <sport-qr-paid-bet-detail
        :allSportBets = "allSportBets"
        :PaidSportBets="PaidSportBets"
        :operatorId="operatorId"
        :operatorToken="operatorToken"
        :isFromPreviousQrPage="isFromPreviousQrPage"
        :totalStakePaidForDisplay="totalStakePaidForDisplay"
        :onRedeemTicket="onRedeemTicket"
        :isRedeemedTicketLoading="isRedeemedTicketLoading"
        :link="link"
      />
    </div>
    <template v-else-if="showInstruction">
      <div class="w-full text-center p-5">
        <span v-if="checkQrUrlApp">{{ sportQrHelper.getLang('Make sure the QR Code you scan is from the player under your account ascash agent', language) }}</span>
        <span v-else>{{ $t('Make sure the QR Code you scan is from the player under your account ascash agent') }}</span>
      </div>
    </template>
    <template v-else-if="isLoading">
      <div v-if="checkQrUrlApp" class="w-full text-center p-5">{{ sportQrHelper.getLang('Loading', language) }}</div>
      <div v-else class="w-full text-center p-5">{{ $t('Loading') }}</div>
    </template>
    <template v-else>
      <div v-if="checkQrUrlApp" class="w-full text-center p-5">{{ sportQrHelper.getLang('No Data', language) }}</div>
      <div v-else class="w-full text-center p-5">{{ $t('NoData') }}</div>
    </template>
  </div>
  <sidebarlanguage />
</template>

<script lang="ts" setup>
import useSportQrCode from "@/composables/useSportQrCode";
import QrcodeVue from "qrcode.vue";
import { generateCryptoToken } from "@/utils/cryptoTokenHelper";
import { IThemePropertiesFromApi } from '~~/models/companyThemePropertiesRespone';
import themePropertyHelper from "@/utils/themePropertyHelper";
import { store } from '~~/store';
import numberFormatHelper from "@/utils/formatHelpers/numberFormatHelper";
import sportQrHelper from '../../utils/sportQrHelper';
import { useLanguageComponent } from "@/composables/useTheme";
import { computed } from "vue";
import sidebarlanguage from "../../components/utils/mobile/sidebar-languages.client.vue";

const themeProperties = computed(
  () => store.state.companyThemePropertiesFromApi.ThemeProperties
);
const logo = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      'logo'
    )
);
const { getAssetImage } = commonHelper;
const dialogVisible = ref<boolean>(true);
const language = useRoute().query.lang ?? "en";
const operatorId = useRoute().query.i ?? 0;
const operatorToken = generateCryptoToken(
  useRoute().query.i?.toString() ?? ""
);
const isFromPreviousQrPage = useRoute().query.pq;
const isFromShopOwner = useRoute().query.isFromShopOwner;
const { getAllSportBets, allSportBets, unPaidSportBets, PaidSportBets, showInstruction,
  totalStakePaidForDisplay, totalStakeUnpaidForDisplay, isLoading, onPayTicket,
  isPayTicketLoading, onRedeemTicket, isRedeemedTicketLoading, totalPayoutForDisplay, currency
} = useSportQrCode();
onMounted(() => {
  getAllSportBets();
});
setInterval(() => {
  getAllSportBets();
}, 10000);

//Generate QR Code Link For Bet Detail View Only
const params = new URLSearchParams(window.location.search);
params.delete("i");
params.delete("pq");
const link = `${window.location.origin}/sport-qr?${params.toString()}`;
const {
  defaultLanguage,
  defaultLanguageForDisplay,
} = useLanguageComponent();
const toggleSidebar = () => {
  store.commit("updateSidebar", !store.state.showSidebar);
};
const qrUrl = computed(() => {
  return window.location.search;
});
const checkQrUrlApp = qrUrl.value.includes('lang=');
</script>

<style lang="scss" scoped>
.icon-lang {
  img {
    object-fit: cover;
    border-radius: 2px;
  }
  height: 16px;
  width: 22px;
  border-radius: 2px;
  overflow: hidden;
}
.m-angle-right-container svg {
  font-size: 16px;
}
</style>
